//Fortran: EQUIVALENCE ( ... )
Unit SF68R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SF68R2_p, SF68R3_p, SF23C_p, QSF3R_p;

procedure SF68R(X0 :Real; R0 :Real; var T10 :Real; var T20 :Real);

implementation

procedure SF68R(X0 :Real; R0 :Real; var T10 :Real; var T20 :Real);
var
IERR,IMET1,IMET2,K,K1,L,L1,L2,M,M1,N :Integer;
A,A0,A3,A4,ARGI,ARGR,B,B3,B4,C1,C2,C3,C4,E,EPS,F,F1,FI,G,G3,H,H3,H4,
   PI,R,RINT1,RINT2,S,S1,S10,S2,S20,U,V :Real;
Q :Boolean;
A1 :Array [0..288] of Real;
A2 :Array [0..288] of Real;
B1 :Array [0..288] of Real;
B2 :Array [0..288] of Real;
C :Array [0..288] of Integer;
G1 :Array [0..16] of Real;
G2 :Array [0..16] of Real;
H1 :Array [0..16] of Real;
H2 :Array [0..16] of Real;
P1 :Array [0..16] of Real;
P2 :Array [0..16] of Real;
U1 :Array [0..16] of Real;
U2 :Array [0..16] of Real;
V1 :Array [0..16] of Real;
V2 :Array [0..16] of Real;
const
SYS001 :Real = 3.1415926535897932384626433832795;
EPS1 :Real = 1.0E-6;
EPS2 :Real = 1.0E-5;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300;
begin
PI := SYS001;   //  EQUIVALENCE
_SF68R1.elm1  := X0;
R  := R0;
if ( X0  <=  6.0 ) or (  R0  >=  4.0 ) 
 then goto _10;
if ( R0  >  0.0 ) and (  R0  <=  1.0 ) and (  X0  >  6.0 ) or ( 
     R0  >  1.0 ) and (  R0  <=  2.0 ) and (  X0  >  7.0 ) 
 then goto _30;
if ( R0  >  2.0 ) and (  R0  <=  3.0 ) and (  X0  >  8.0 ) or ( 
     R0  >  3.0 ) and (  R0  <=  4.0 ) and (  X0  >  9.0 ) 
 then goto _50;
_10:
IMET1  := 0;
goto _140;
_20:
T10  := S10;
goto _70;
_30:
IMET2  := 0;
goto _160;
_40:
T10  := S1;
goto _70;
_50:
Q  := False;
goto _270;
_60:
T10  := S;
_70:
if ( X0  <=  4.0 ) or (  R0  >=  6.0 ) 
 then goto _80;
if ( R0  >  0.0 ) and (  R0  <=  1.0 ) and (  X0  >  4.0 ) or ( 
     R0  >  1.0 ) and (  R0  <=  2.0 ) and (  X0  >  6.0 ) 
 then goto _100;
if ( R0  >  2.0 ) and (  R0  <=  3.0 ) and (  X0  >  6.0 ) or ( 
     R0  >  3.0 ) and (  R0  <=  4.0 ) and (  X0  >  8.0 ) or ( 
     R0  >  4.0 ) and (  R0  <=  6.0 ) and (  X0  >  9.0 ) 
 then goto _120;
_80:
IMET1  := 1;
goto _140;
_90:
T20  := S20;
goto _300;
_100:
IMET2  := 1;
goto _160;
_110:
T20  := S2;
goto _300;
_120:
Q  := True;
goto _270;
_130:
T20  := S;
goto _300;
{      HAAO BCEH KOMEKCHO AMMA-YHK }
_140:
EPS  := EPS1;
L  := 1;
ARGR  := 1.5;
ARGI  := R;
SF23C(ARGR,ARGI,U,V,EPS,L,IERR);
{      OKOHAHE BCEH KOMEKCHO AMMA-YHK }
F  := Sqrt(_SF68R1.elm1/2.0)*Cos(R*Ln(_SF68R1.elm1/2.0));
G  := Sqrt(_SF68R1.elm1/2.0)*Sin(R*Ln(_SF68R1.elm1/2.0));
A  := (F*U + G*V)/(IntPower(U,2) + IntPower(V,2));
B  := (G*U - F*V)/(IntPower(U,2) + IntPower(V,2));
S1  := A;
S2  := B;
F  := Cos(R*Ln(_SF68R1.elm1/2.0))/Sqrt(_SF68R1.elm1/2.0);
G  := -Sin(R*Ln(_SF68R1.elm1/2.0))/Sqrt(_SF68R1.elm1/2.0);
F1  := F/2.0+ G*R;
G3  := G/2.0- F*R;
A3  := (F1*U - G3*V)/(IntPower(U,2) + IntPower(V,2));
B3  := (G3*U + F1*V)/(IntPower(U,2) + IntPower(V,2));
H3  := A3;
H4  := B3;
H  := PI/(Exp(PI*R) + Exp(-PI*R));
for K:=1 to 55 do
 begin
  C3  := A;
  C4  := A3;
  A  := IntPower(_SF68R1.elm1,2)*(A*(K + 0.5) + B*R)/(4*K*(IntPower(K + 0.5,2)+IntPower(R,2)));
  B  := IntPower(_SF68R1.elm1,2)*(B*(K + 0.5) - C3*R)/(4*K*(IntPower(K + 0.5,2)+IntPower(R,2)));
  A3  := IntPower(_SF68R1.elm1,2)*(A3*(K - 0.5) - B3*R)/(4*K*(IntPower(K - 0.5,2)+IntPower(R,2)));
  B3  := IntPower(_SF68R1.elm1,2)*(C4*R + B3*(K - 0.5))/(4*K*(IntPower(K - 0.5,2)+IntPower(R,2)));
  S1  := S1 + A;
  S2  := S2 + B;
  H3  := H3 + A3;
  H4  := H4 + B3;
_150:
 end;
S10  := (H3 - S1)*H;
S20  := (H4 - S2)*H;
if ( IMET1 ) < 0
 then goto _20
 else if ( IMET1 ) > 0
       then goto _90
       else goto _20;
_160:
for N:=2 to 17 do
 begin
  C[0+(N-1)*17] := Trunc(Power(-1,N - 1));
  for M:=2 to N do
   begin
    C[(M-1)+(N-1)*17] := -C[(M-2)+(N-1)*17]*2*(N + M - 3)*(N - M + 1) div ((M - 1)*
    (2*(M - 1)));
_170:
   end;
_180:
 end;
A1[0] := 1.0/(R*(IntPower(R,2) + 1.0));
B1[0] := 1.0/(IntPower(R,2) + 1.0);
A2[0] := 1.0/(IntPower(R,2) + 1.0);
B2[0] := -1.0/(R*(IntPower(R,2) + 1.0));
H1[0] := A1[0];
P1[0] := B1[0];
H2[0] := A2[0];
P2[0] := B2[0];
for M:=2 to 17 do
 begin
  C1  := IntPower(R,2) + M*(M - 1);
  A1[(M-1)+(M-1)*17] := R/(IntPower(C1,2) + IntPower(R,2));
  B1[(M-1)+(M-1)*17] := C1/(IntPower(C1,2) + IntPower(R,2));
  A2[(M-1)+(M-1)*17] := C1/(IntPower(C1,2) + IntPower(R,2));
  B2[(M-1)+(M-1)*17] := -R/(IntPower(C1,2) + IntPower(R,2));
  M1  := M - 1;
  for K1:=1 to M1 do
   begin
    K  := M - K1;
    C2  := IntPower(R,2) + K*(K - 1);
    A1[(K-1)+(M-1)*17] := -2.0*K*(R*B1[(K+0)+(M-1)*17] + C2*A1[(K+0)+(M-1)*17])/(IntPower(C2,2) +
    IntPower(R,2));
    B1[(K-1)+(M-1)*17] := 2.0*K*(R*A1[(K+0)+(M-1)*17] - C2*B1[(K+0)+(M-1)*17])/(IntPower(C2,2) +
    IntPower(R,2));
    A2[(K-1)+(M-1)*17] := -2.0*K*(R*B2[(K+0)+(M-1)*17] + C2*A2[(K+0)+(M-1)*17])/(IntPower(C2,2) +
    IntPower(R,2));
    B2[(K-1)+(M-1)*17] := 2.0*K*(R*A2[(K+0)+(M-1)*17] - C2*B2[(K+0)+(M-1)*17])/(IntPower(C2,2) +
    IntPower(R,2));
_190:
   end;
_200:
 end;
for N:=2 to 17 do
 begin
  U1[N-1] := 0;
  U2[N-1] := 0;
  V1[N-1] := 0;
  V2[N-1] := 0;
  for M:=1 to N do
   begin
    U1[N-1] := U1[N-1] + C[(M-1)+(N-1)*17]*B1[0+(M-1)*17];
    U2[N-1] := U2[N-1] + C[(M-1)+(N-1)*17]*A1[0+(M-1)*17];
    V1[N-1] := V1[N-1] + C[(M-1)+(N-1)*17]*B2[0+(M-1)*17];
    V2[N-1] := V2[N-1] + C[(M-1)+(N-1)*17]*A2[0+(M-1)*17];
_210:
   end;
  G1[N-1] := V2[N-1]/(U1[N-1]*V2[N-1] - U2[N-1]*V1[N-1]);
  G2[N-1] := U2[N-1]/(V1[N-1]*U2[N-1] - V2[N-1]*U1[N-1]);
_220:
 end;
for M:=2 to 17 do
 begin
  P1[M-1] := 0;
  H1[M-1] := 0;
  P2[M-1] := 0;
  H2[M-1] := 0;
  for K:=1 to M do
   begin
    P1[M-1] := P1[M-1] + B1[(K-1)+(M-1)*17]*Power(1.0/_SF68R1.elm1,K - 1);
    H1[M-1] := H1[M-1] + A1[(K-1)+(M-1)*17]*Power(1.0/_SF68R1.elm1,K - 1);
    P2[M-1] := P2[M-1] + B2[(K-1)+(M-1)*17]*Power(1.0/_SF68R1.elm1,K - 1);
    H2[M-1] := H2[M-1] + A2[(K-1)+(M-1)*17]*Power(1.0/_SF68R1.elm1,K - 1);
_230:
   end;
_240:
 end;
for N:=2 to 17 do
 begin
  S1  := 0;
  S2  := 0;
  for M:=1 to N do
   begin
    S1  := S1 + C[(M-1)+(N-1)*17]*(G1[N-1]*P1[M-1] + G2[N-1]*P2[M-1]);
    S2  := S2 + C[(M-1)+(N-1)*17]*(G1[N-1]*H1[M-1] + G2[N-1]*H2[M-1]);
_250:
   end;
_260:
 end;
S1  := Sqrt(PI/(2.0*_SF68R1.elm1))*Exp(-_SF68R1.elm1)*S1;
S2  := Sqrt(PI/(2.0*_SF68R1.elm1))*Exp(-_SF68R1.elm1)*S2;
if ( IMET2 ) < 0
 then goto _40
 else if ( IMET2 ) > 0
       then goto _110
       else goto _40;
_270:
A4  := 0.0;
B4  := 5.0;
FI  := 0.0;
E  := EPS2;
L1  := 0;
L2  := 1;
if ( Q ) 
 then goto _280;
QSF3R(RINT1,RINT2,A4,B4,SF68R2,R,FI,E,L1,L2);
A0  := RINT2;
goto _290;
_280:
QSF3R(RINT1,RINT2,A4,B4,SF68R3,R,FI,E,L1,L2);
A0  := RINT1;
_290:
S  := A0*Exp(-_SF68R1.elm1)/2.0;
if ( Q ) 
 then goto _130;
goto _60;
_300:
end;

end.
